Index: CMT/v1r20p20070524/doc/CMTDownload.html
===================================================================
--- CMT/v1r20p20070524/doc/CMTDownload.html	(revision 418)
+++ CMT/v1r20p20070524/doc/CMTDownload.html	(revision 419)
@@ -1,4 +1,3 @@
-<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
-<html><head><!--
+<!--
 //-----------------------------------------------------------
 // Copyright Christian Arnault LAL-Orsay CNRS
@@ -6,28 +5,14 @@
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
---><title>CMTDownload</title><!-- Changed by: Christian Arnault, 10-Apr-2002 --><!-- phpmyvisites -->
-        
+-->
 
-<script type="text/javascript">
-<!--
-var a_vars = Array();
-var pagename='';
-
-var phpmyvisitesSite = 1;
-var phpmyvisitesURL = "http://www.cmtsite.org/phpmv2/phpmyvisites.php";
-//-->
-</script><script language="javascript" src="CMTDownload_fichiers/phpmyvisites.js" type="text/javascript"></script></head><body alink="#007777" bgcolor="#ffffff" link="#550088"><a href="http://www.phpmyvisites.net/" title="phpMyVisites | Open source web analytics" onclick="window.open(this.href);return(false);">
-
-<img src="CMTDownload_fichiers/phpmyvisites.gif" alt="phpMyVisites" style="border: 0pt none ;">
-
-<noscript>
-<p>phpMyVisites | Open source web analytics
-<img src="http://www.cmtsite.org/phpmv2/phpmyvisites.php" alt="phpMyVisites" style="border:0" />
-</p>
-</noscript>
-</a>
-<!-- /phpmyvisites -->
-
+<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
+<html>
+  <head>
+    <title>CMTDownload</title>
+    <!-- Changed by: Christian Arnault, 10-Apr-2002 -->
+  </head>
   
+  <body BGCOLOR="#FFFFFF" link="#550088" alink="#007777" alink="#007777">
     <h1>CMTDownload</h1>
 
@@ -43,18 +28,15 @@
 
       <center>
-	<table border="1" cols="1">
-
-<tbody><tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19.tar.gz">Source kit</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19OSF1-alpha.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19OSF1-alpha.tar.gz">OSF1-alpha</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19Linux-i686.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19Linux-i686.tar.gz">Linux-i686</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19Linux-x86_64.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19Linux-x86_64.tar.gz">Linux-x86_64</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19Linux-ia64.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19Linux-ia64.tar.gz">Linux-ia64</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/v1r19/CMTv1r19SunOS-sun4u.tar.gz">SunOS-sun4u</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/v1r19/CMTv1r19AIX-002064874C00.tar.gz">AIX-002064874C00</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19VisualC.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19VisualC.tar.gz">VisualC</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/v1r19/CMTv1r19CYGWIN_NT-5.1-i686.tar.gz">CYGWIN_NT-5.1-i686</a> </td></tr>
-<tr><td><a href="http://www.cmtsite.org/phpmv2/phpmyvisites.php?url=http://www.cmtsite.org/v1r19/CMTv1r19Darwin-PowerMacintosh.tar.gz&amp;id=1&amp;pagename=FILE:CMTv1r19Darwin-PowerMacintosh.tar.gz">Darwin-PowerMacintosh</a> </td></tr>
-
-
+	<table BORDER COLS=1 >
+  <tr><td><a href="CMTv1r20p20070524.tar.gz">Source kit</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524OSF1-alpha.tar.gz">OSF1-alpha</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524Linux-i686.tar.gz">Linux-i686</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524Linux-x86_64.tar.gz">Linux-x86_64</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524Linux-ia64.tar.gz">Linux-ia64</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524SunOS-sun4u.tar.gz">SunOS-sun4u</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524AIX-002064874C00.tar.gz">AIX-002064874C00</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524VisualC.tar.gz">VisualC</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524CYGWIN_NT-5.1-i686.tar.gz">CYGWIN_NT-5.1-i686</a> </td></tr>
+  <tr><td><a href="CMTv1r20p20070524Darwin-PowerMacintosh.tar.gz">Darwin-PowerMacintosh</a> </td></tr>
 <!--
 //-----------------------------------------------------------
@@ -66,13 +48,14 @@
 
 
-	</tbody></table>
+	</table>
       </center>
 
 
     <hr>
-    <address><a href="mailto:garonne@lal.in2p3.fr">vincent Garonne</a></address>
+    <address><a href="mailto:arnault@lal.in2p3.fr">Christian Arnault</a></address>
     <!-- Created: Thu Feb  3 15:55:09 MET 2000 -->
     <!-- hhmts start -->
-Last modified: Wed Nov 22 15:55:11 CEST 2006
+Last modified: Wed May 22 15:55:11 CEST 2002
 <!-- hhmts end -->
-  </body></html>
+  </body>
+</html>