Index: /CMT/HEAD/ChangeLog
===================================================================
--- /CMT/HEAD/ChangeLog	(revision 445)
+++ /CMT/HEAD/ChangeLog	(revision 446)
@@ -1,2 +1,12 @@
+2008-02-22    <rybkin@lal.in2p3.fr> 350
+	
+	* src/NMakefile.core: Replace CMTMSGHDR with CMTMSGPREFIX
+	* src/Makefile.core: idem
+	* mgr/cmt_install_action.sh: idem
+	* mgr/cmt_uninstall_action.sh: idem
+	* mgr/cmt_make_shlib.sh: idem
+	* mgr/fragments/cleanup_header: Improve diagnostic messages
+	* mgr/fragments/tex: Correct the fragment
+	
 2008-02-21    <rybkin@lal.in2p3.fr> 349
 	
Index: /CMT/HEAD/mgr/cmt_install_action.sh
===================================================================
--- /CMT/HEAD/mgr/cmt_install_action.sh	(revision 445)
+++ /CMT/HEAD/mgr/cmt_install_action.sh	(revision 446)
@@ -26,5 +26,5 @@
 # 5   cmtpath of the package
 #------------------------------------------------------------------------------
-: ${CMTMSGHDR:=$0:}
+: ${CMTMSGPREFIX:=$0:}
 
 source_dir=""
@@ -144,5 +144,5 @@
 
 if test "${cmtmsg}"; then
-echo "${CMTMSGHDR}" "installing file ${file_name} into ${install_dir}"
+echo "${CMTMSGPREFIX}" "installing file ${file_name} into ${install_dir}"
 fi
 if test "${makecmd}"; then set -v; fi
Index: /CMT/HEAD/mgr/cmt_make_shlib.sh
===================================================================
--- /CMT/HEAD/mgr/cmt_make_shlib.sh	(revision 445)
+++ /CMT/HEAD/mgr/cmt_make_shlib.sh	(revision 446)
@@ -2,5 +2,5 @@
 
 #set -x
-: ${CMTMSGHDR:=$0:}
+: ${CMTMSGPREFIX:=$0:}
 
 lib=$1
@@ -37,5 +37,5 @@
 if test `uname` = "Linux" ; then
 if test "${cmtmsg}"; then
-  echo "${CMTMSGHDR}" "BUILDING SHARED LIBRARY ${lib}"
+  echo "${CMTMSGPREFIX}" "BUILDING SHARED LIBRARY ${lib}"
 fi
 # ATTEMPT 2: temp for sharedlin force
Index: /CMT/HEAD/mgr/cmt_uninstall_action.sh
===================================================================
--- /CMT/HEAD/mgr/cmt_uninstall_action.sh	(revision 445)
+++ /CMT/HEAD/mgr/cmt_uninstall_action.sh	(revision 446)
@@ -23,5 +23,5 @@
 # 4   cmtpath of the package
 #------------------------------------------------------------------------------
-: ${CMTMSGHDR:=$0:}
+: ${CMTMSGPREFIX:=$0:}
 
 source_dir=""
@@ -124,5 +124,5 @@
 if test -d ${dest_file_path}; then
 if test "${cmtmsg}"; then
-  echo "${CMTMSGHDR}" removing directory ${file_name} from ${install_dir}
+  echo "${CMTMSGPREFIX}" removing directory ${file_name} from ${install_dir}
 fi
 if test "${makecmd}"; then set -v; fi
@@ -131,5 +131,5 @@
 elif test -f ${dest_file_path}; then
 if test "${cmtmsg}"; then
-  echo "${CMTMSGHDR}" removing file ${file_name} from ${install_dir}
+  echo "${CMTMSGPREFIX}" removing file ${file_name} from ${install_dir}
 fi
 if test "${makecmd}"; then set -v; fi
Index: /CMT/HEAD/mgr/fragments/cleanup_header
===================================================================
--- /CMT/HEAD/mgr/fragments/cleanup_header	(revision 445)
+++ /CMT/HEAD/mgr/fragments/cleanup_header	(revision 446)
@@ -6,11 +6,11 @@
 ifndef PEDANTIC
 .DEFAULT::
-	@echo "WARNING >> You should provide a target for $@"
+	@echo "#CMT> Warning: $@: No rule for such target" >&2; exit
 else
 .DEFAULT::
-	@echo "PEDANTIC MODE >> You should provide a target for $@"
+	@echo "#CMT> PEDANTIC MODE >> No rule for target $@" >&2
 	@if test `expr index $@ '.'` != 0 ; \
-	then  echo "PEDANTIC MODE >> This target seems to be a missing file, please check"; exit -1 ;\
-	else echo "PEDANTIC MODE >> Just ignore it ; as it seems to be just a fake target due to some pattern" ; exit 0; fi; 		
+	then  echo "#CMT> PEDANTIC MODE >> $@ seems to be a missing file, please check" >&2; exit -1 ;\
+	else echo "#CMT> PEDANTIC MODE >>  $@ seems to be a fake target due to some pattern. Just ignore it." >&2 ; exit 0; fi; 		
 endif
 
Index: /CMT/HEAD/mgr/fragments/tex
===================================================================
--- /CMT/HEAD/mgr/fragments/tex	(revision 445)
+++ /CMT/HEAD/mgr/fragments/tex	(revision 446)
@@ -3,14 +3,14 @@
 ${CONSTITUENT} :: ${FILEPATH}${NAME}.ps
 
-${FILEPATH}${NAME}.dvi : ${NAME}${FILESUFFIX}
-	cd ${doc}; latex ${NAME}${FILESUFFIX}
+${FILEPATH}${NAME}.dvi : ${FULLNAME}
+	$(silent) cd ${FILEPATH}; latex ${NAME}${FILESUFFIX}
 
 ${FILEPATH}${NAME}.ps : ${FILEPATH}${NAME}.dvi
-	cd ${doc}; dvips -o ${NAME}.ps ${NAME}.dvi
+	$(silent) cd ${FILEPATH}; dvips -o ${NAME}.ps ${NAME}.dvi
 
 ${CONSTITUENT}clean ::
-	$(cleanup_echo) ${doc}/${NAME}.ps
-	$(cleanup_silent) cd ${doc}; /bin/rm -f ${NAME}.ps ${NAME}.dvi
-	$(cleanup_silent) cd ${doc}; /bin/rm -f ${NAME}.aux ${NAME}.log ${NAME}.toc
+	$(cleanup_echo) ${FILEPATH}${NAME}.ps
+	$(cleanup_silent) cd ${FILEPATH}; /bin/rm -f ${NAME}.ps ${NAME}.dvi
+	$(cleanup_silent) cd ${FILEPATH}; /bin/rm -f ${NAME}.aux ${NAME}.log ${NAME}.toc
 
 #-- end of tex ------
Index: /CMT/HEAD/src/Makefile.core
===================================================================
--- /CMT/HEAD/src/Makefile.core	(revision 445)
+++ /CMT/HEAD/src/Makefile.core	(revision 446)
@@ -69,12 +69,12 @@
 
 # set the relevant Make variables
-ifndef CMTMSGHDR
-CMTMSGHDR = \#CMT--->
-export CMTMSGHDR
+ifndef CMTMSGPREFIX
+CMTMSGPREFIX = \#CMT--->
+export CMTMSGPREFIX
 endif
 
 ifdef cmtmsg
 export cmtmsg
-echo = @- echo "$(CMTMSGHDR)"
+echo = @- echo "$(CMTMSGPREFIX)"
 else
 echo = @:
Index: /CMT/HEAD/src/NMakefile.core
===================================================================
--- /CMT/HEAD/src/NMakefile.core	(revision 445)
+++ /CMT/HEAD/src/NMakefile.core	(revision 446)
@@ -69,12 +69,12 @@
 
 # set the relevant Make variables
-!ifndef CMTMSGHDR
-CMTMSGHDR = ^#CMT--->
-#export CMTMSGHDR
+!ifndef CMTMSGPREFIX
+CMTMSGPREFIX = ^#CMT--->
+#export CMTMSGPREFIX
 !endif
 
 !ifdef cmtmsg
 #export cmtmsg
-echo = @ echo "$(CMTMSGHDR)"
+echo = @ echo "$(CMTMSGPREFIX)"
 !else
 #echo = @: